ALTER TABLE SMS
ADD ID_SMS_TEMPLATE NUMBER;

ALTER TABLE SMS
ADD CONSTRAINT SMS_ID_SMS_TEMPLATE_FK
FOREIGN KEY (ID_SMS_TEMPLATE)
REFERENCES SMS_TEMPLATE(ID_SMS_TEMPLATE);

ALTER TABLE NNPRIKLJ
ADD ID_AMPERAGE_TYPE NUMBER;

ALTER TABLE NNPRIKLJ
ADD CONSTRAINT NNPRIKLJ_ID_AMPERAGE_TYPE_FK
FOREIGN KEY (ID_AMPERAGE_TYPE)
REFERENCES NN_AMPERAGE_TYPE(ID_AMPERAGE_TYPE);

DROP VIEW V_NNPRIKLJ;

CREATE OR REPLACE VIEW V_NNPRIKLJ AS (
SELECT NN.NNPRIKLJ_ID, NN.ID_PRIVEZ, NN.OZNAKA, NN.PRIKLJ, NN.ZACETNO_STANJE, NN.KONCNO_STANJE, NN.ZASEDEN, NN.INTERNI_OPIS, NN.OPIS, NN.EXT_DATE AS NNPRIKLJ_EXT_DATE, NN.EXT_PONTOON, NN.EXT_SOCKET, 
NN.VOLTAGE, NN.AMPERAGE, NN.ID_AMPERAGE_TYPE, NN.EUUS, NN.METER_HW_VALUE, NN.EXT_ID, NN.STATUS, NN.SYSTEM_TYPE, NN.ACTIVE, NN.SORT, 
N.OPIS AS NPRIKLJ_OPIS, N.INTERNI_OPIS AS NPRIKLJ_INTERNI_OPIS, N.STORITEV AS NPRIKLJ_STORITEV, N.NPRIKLJ_TYPE AS NPRIKLJ_TYPE, N.STATE_CHECK AS NPRIKLJ_STATE_CHECK,
P.ID_PRIKLJ AS PRIKLJ_ID_PRIKLJ, P.ID_LASTNIKA AS PRIKLJ_ID_LASTNIKA, P.ID_PLOVILA AS PRIKLJ_ID_PLOVILA, P.ID AS PRIKLJ_ID, P.ID_STORITVE AS PRIKLJ_ID_STORITVE, P.OZNAKA AS PRIKLJ_OZNAKA, 
P.PRIKLJUCEK AS PRIKLJ_PRIKLJUCEK, P.DATUM_ZACETKA AS PRIKLJ_DATUM_ZACETKA, P.DATUM_KONCA AS PRIKLJ_DATUM_KONCA, P.ZACETNO_STANJE AS PRIKLJ_ZACETNO_STANJE, P.KONCNO_STANJE AS PRIKLJ_KONCNO_STANJE, 
P.ZASEDEN AS PRIKLJ_ZASEDEN, P.OBRACUNAN AS PRIKLJ_OBRACUNAN, P.STEVEC_HW_STANJE AS PRIKLJ_STEVEC_HW_STANJE,
NNP.OBJEKT AS NNPRIVEZ_OBJEKT, NNP.N_PRIVEZA AS NNPRIVEZ_N_PRIVEZA, NNP.KATEGORIJA AS NNPRIVEZ_KATEGORIJA, NNP.SORT_PRIKAZ AS NNPRIVEZ_SORT_PRIKAZ, NNPOM.SORT AS NNPOMOL_SORT,
K.PRIIMEK AS KUPCI_PRIIMEK, K.IME AS KUPCI_IME, PL.IME AS PLOVILA_IME, VPL.NNLOCATION_ID, VOL.OPIS AS VOLTAGE_OPIS, AMP.OPIS AS AMPERAGE_OPIS, EUS.OPIS AS EUUS_OPIS,
COALESCE(P.ZACETNO_STANJE, NN.ZACETNO_STANJE) AS PREVIOUS_STATE, NN.KONCNO_STANJE - COALESCE(P.ZACETNO_STANJE, NN.ZACETNO_STANJE) AS CONSUMPTION,
C.BRUTO_DOMACA_VALUTA AS PRICE_PER_UNIT, (NN.KONCNO_STANJE - COALESCE(P.ZACETNO_STANJE, NN.ZACETNO_STANJE))*C.BRUTO_DOMACA_VALUTA*COALESCE(N.METER_RATIO, 1) AS CONSUMPTION_PRICE
FROM NNPRIKLJ NN
JOIN (SELECT NNI.NNPRIKLJ_ID, CASE WHEN (NNI.ZASEDEN = 'Y') THEN (SELECT MAX(PI.ID_PRIKLJ) FROM PRIKLJ PI WHERE PI.NNPRIKLJ_ID=NNI.NNPRIKLJ_ID) ELSE NULL END AS PRIKLJ_ID FROM NNPRIKLJ NNI) NNI ON NNI.NNPRIKLJ_ID = NN.NNPRIKLJ_ID 
LEFT OUTER JOIN NPRIKLJ N ON NN.OZNAKA=N.SIFRA
LEFT OUTER JOIN NNPRIVEZ NNP ON NNP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN NNPOMOL NNPOM ON NNPOM.SIFRA = NNP.KATEGORIJA
LEFT OUTER JOIN PRIKLJ P ON P.ID_PRIKLJ = NNI.PRIKLJ_ID
LEFT OUTER JOIN KUPCI K ON P.ID_LASTNIKA = K.ID
LEFT OUTER JOIN PLOVILA PL ON P.ID_PLOVILA = PL.ID
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPL ON VPL.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN NN_VOLTAGE VOL ON VOL.ID = NN.VOLTAGE
LEFT OUTER JOIN NN_AMPERAGE AMP ON AMP.ID = NN.AMPERAGE
LEFT OUTER JOIN NN_EUUS EUS ON EUS.ID = NN.EUUS
LEFT OUTER JOIN (SELECT M_NNCENMAR.*, RANK() OVER (PARTITION BY STORITEV ORDER BY ID_M_NNCENMAR DESC) RNK FROM M_NNCENMAR) C ON (C.STORITEV = N.STORITEV AND (C.NNLOCATION_ID IS NULL OR C.NNLOCATION_ID = NNPOM.NNLOCATION_ID) AND C.RNK = 1)
);

DROP VIEW V_SMS;

CREATE OR REPLACE VIEW V_SMS
AS (
SELECT S.ID, S.RECEIVER, S.SUBJECT, S.CONTENT, S.STATUS, S.SMS_FILE, S.DATE_CREATED, S.USER_CREATED, S.STATUS_MESSAGE, S.NNLOCATION_ID, S.ID_SMS_TEMPLATE,
K.ID AS KUPCI_ID, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, K.MANAGER AS KUPCI_MANAGER, K.VRSTA AS KUPCI_VRSTA,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER
FROM SMS S
LEFT OUTER JOIN (SELECT ID_KUPCA, ID_SMS, NPISMO, RANK() OVER (PARTITION BY ID_SMS ORDER BY ID_OPOMINI ASC) RNK FROM OPOMINI) O ON (O.ID_SMS = S.ID AND O.RNK = 1 AND O.NPISMO = 'S')
LEFT OUTER JOIN KUPCI K ON O.ID_KUPCA = K.ID
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (2309, SYSDATE, '5.5', 2229, 'Nnpriklj idAmperageType')
;
